#include <cstddef>
//typedef desired-type-of-list-item ListItemType;
typedef int ListItemType;

class ListNode // a node on the list
{
private:
   ListNode(): next(NULL) {};
   ListNode(const ListItemType &nodeItem, ListNode *ptr)
           : item(nodeItem), next(ptr) {};
   ListItemType item; // a data item on the list
   ListNode *next; // pointer to next node

   // friend class - can access private parts
   friend class List;
   // The following is needed when ListIterator is used
   //    friend class ListIterator;
}; // end class

